//+------------------------------------------------------------------+
//|                                                         VQ35.mq4 |
//|                                   http://davidke20.blogspot.com/ |
//+------------------------------------------------------------------+
#property copyright "Alejandro Gallindo"
#property link      "http://davidke20.blogspot.com/"

//int Account=1416863;
extern string     Trades_setup;
extern int        Magic                   = 772188;
extern double     TakeProfit              = 150;
extern double     Lots                    = 0.01;
extern double     MaxInitialLots          = 6;
extern double     InitialStop             = 0;
extern double     TrailingStop            = 70;
extern bool       Money_management        = true;
extern double     risk                    = 2;
extern string     Martingale_setup;
extern int        MaxTrades               = 5;
extern int        Pips                    = 50;
extern double     Multiplier              = 2;
extern bool       AccountProtection       = true;
extern bool       GlobalEquityProtect     = true;
extern int        OrderstoProtect         = 2;
extern string     Signal_option;
extern string     BullsNBears;
extern int        Fast_Period             = 5;
extern int        Slow_Period             = 13;
extern string     MACD;
extern int        Fast_MA                 = 14;
extern int        Slow_MA                 = 26;
extern int        MACD_SMA                = 9;
extern string     Stochastic;
extern int        K_Period                = 8;
extern int        D_Period                = 3;
extern int        Slowing                 = 4;
extern double     Overbought              = 80;
extern double     Oversold                = 20;
extern int        RSI_Period              = 5;
extern int        MFI_Period              = 5;
extern int        Shift                   = 0;
extern int        ReverseCondition        = 0;
extern string     Conservative_1_Intermediate_2;
extern string     Agressive_3_Berserk_4;
extern int        Engine_Mode             = 3;
extern int        FromHourTrade           = 0;
extern int        ToHourTrade             = 12;

//int EndYear=2007;
//int EndMonth=7;
double LotSizeValue, LotStep, MinLots, MaxLots;
int  OpenOrders=0, cnt=0;
int  slippage=5;
double sl=0, tp=0;
double BuyPrice=0, SellPrice=0;
double lotsi=0, mylotsi=0;
int mode=0, myOrderType=0;
bool ContinueOpening=True;
double LastPrice=0;
int  PreviousOpenOrders=0;
double Profit=0;
int LastTicket=0, LastType=0;
double LastClosePrice=0, LastLots=0;
double Pivot=0;
double PipValue=0;
string text,text2,engine;
double SecureProfit=1;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
     if(Period()<30){Comment("Do not use anything below M30");return;}
//***----------------------------------------------------------------***
//***LotSize Conversion across Standard or Mini Accounts, by deeforex***
//***----------------------------------------------------------------***

// add this to the variables
//double LotSizeValue, LotStep, MinLots, MaxLots;

  LotSizeValue = NormalizeDouble((MarketInfo(Symbol(), MODE_LOTSIZE)),0);   
  LotStep = NormalizeDouble((MarketInfo(Symbol(), MODE_LOTSTEP)),2);
  MinLots = NormalizeDouble((MarketInfo(Symbol(), MODE_MINLOT)),2);
  MaxLots = NormalizeDouble((MarketInfo(Symbol(), MODE_MAXLOT)),2);
  if(MaxInitialLots>0) MaxLots=MaxInitialLots;

   if (Money_management)
   {
      //Standard Account offering $10,000 lotstep
      if (LotSizeValue == 100000 && LotStep == 0.10)
      {
      lotsi = NormalizeDouble(((AccountBalance() * (risk/100) ) / ((LotSizeValue * LotStep)/10)),1);
      if (lotsi < MinLots) lotsi = MinLots;
      if (lotsi > MaxLots) lotsi = MaxLots;      
      }
      
      //Standard Account offering $1,000 lotstep
      if (LotSizeValue == 100000 && LotStep == 0.01)
      {
      lotsi = NormalizeDouble(((AccountBalance() * (risk/100) ) / (LotSizeValue * LotStep)),2); 
      if (lotsi < MinLots) lotsi = MinLots;
      if (lotsi > MaxLots) lotsi = MaxLots;      
      }
      
      //IBFX mini Account offering $100 lotstep
      if (LotSizeValue == 10000  && LotStep == 0.01)
      {
      lotsi = NormalizeDouble(((AccountBalance() * (risk/100) ) / (LotSizeValue * LotStep)),2); 
      if (lotsi < MinLots) lotsi = MinLots;
      if (lotsi > MaxLots) lotsi = MaxLots;      
      }      
   
   }
   else lotsi = Lots;
//-- End of money management

   OpenOrders=0;
   for(cnt=0;cnt<OrdersTotal();cnt++)   
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic)
	  {				
	  	  OpenOrders++;
	  }
   }     
   
   if (OpenOrders<1)
   PipValue=MarketInfo(Symbol(),MODE_TICKVALUE);
   if (PipValue==0) { PipValue=10; }
   
   if (PreviousOpenOrders>OpenOrders) 
   {	  
	  for(cnt=OrdersTotal();cnt>=0;cnt--)
	  {
	     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  	  mode=OrderType();
		  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
		  {
			if (mode==OP_BUY) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage,Blue); }
			if (mode==OP_SELL) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage,Red); }
			return(0);
		 }
	  }
   }

   PreviousOpenOrders=OpenOrders;
   if (OpenOrders>=MaxTrades) 
   {
	  ContinueOpening=False;
   } else {
	  ContinueOpening=True;
   }

   if (LastPrice==0) 
   {
	  for(cnt=0;cnt<OrdersTotal();cnt++)
	  {	
	    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
		 mode=OrderType();	
		 if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
		 {
			LastPrice=OrderOpenPrice();
			if (mode==OP_BUY) { myOrderType=2; }
			if (mode==OP_SELL) { myOrderType=1;	}
		 }
	  }
   }

   if (OpenOrders<1) 
   {
     if (Engine_Mode!=4)
     {//check trading time
        if ((!(Hour()>FromHourTrade && Hour()<ToHourTrade)) && (DayOfWeek()==5)) 
        {Comment("No trading, danger time zone!");
        return(0);}//End of trading time check
     }
//	  if (TimeYear(CurTime())>EndYear) { return(0); }
//	  if (TimeMonth(CurTime())>EndMonth ) { return(0); }
      //Check Account authorization
//      if (Account != AccountNumber()){Comment("Trade on account :"+AccountNumber()+" FORBIDDEN!");
//      return(0);}//End of authorization
   switch(Engine_Mode)
   {
      case 1: {Magic=Magic+Engine_Mode;myOrderType=Conservative();engine=" Conservative";}
      case 2: {Magic=Magic+Engine_Mode;myOrderType=Intermediate();engine=" Intermediate";}
      case 3: {Magic=Magic+Engine_Mode;myOrderType=Agressive();engine=" Agressive";}
      case 4: {Magic=Magic+Engine_Mode;myOrderType=Berserk();engine=" Berserk";}
      default: {Magic=Magic+Engine_Mode;myOrderType=Agressive();engine=" Agressive";}
   }

	  if (ReverseCondition==1)
	  {
	  	  if (myOrderType==1) { myOrderType=2; }
		  else { if (myOrderType==2) { myOrderType=1; } }
	  }
   }

   // if we have opened positions we take care of them
   for(cnt=OrdersTotal();cnt>=0;cnt--)
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic) 
	  {	
	  	  if (OrderType()==OP_SELL) 
	  	  {			
	  	  	  if (TrailingStop>0) 
			  {
				  if (OrderOpenPrice()-Ask>=(TrailingStop+Pips)*Point) 
				  {						
					 if (OrderStopLoss()>(Ask+Point*TrailingStop))
					 {			
					    OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderClosePrice()-TakeProfit*Point-TrailingStop*Point,800,Purple);
	  					 return(0);	  					
	  				 }
	  			  }
			  }
	  	  }
   
	  	  if (OrderType()==OP_BUY)
	  	  {
	  		 if (TrailingStop>0) 
	  		 {
			   if (Bid-OrderOpenPrice()>=(TrailingStop+Pips)*Point) 
				{
					if (OrderStopLoss()<(Bid-Point*TrailingStop)) 
					{					   
					   OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderClosePrice()+TakeProfit*Point+TrailingStop*Point,800,Yellow);
                  return(0);
					}
  				}
			 }
	  	  }
   	}
   }
   
   Profit=0;
   LastTicket=0;
   LastType=0;
	LastClosePrice=0;
	LastLots=0;	
	for(cnt=0;cnt<OrdersTotal();cnt++)
	{
	  OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
	  {			
	  	   LastTicket=OrderTicket();
			if (OrderType()==OP_BUY) { LastType=OP_BUY; }
			if (OrderType()==OP_SELL) { LastType=OP_SELL; }
			LastClosePrice=OrderClosePrice();
			LastLots=OrderLots();
			if (LastType==OP_BUY) 
			{
				//Profit=Profit+(Ord(cnt,VAL_CLOSEPRICE)-Ord(cnt,VAL_OPENPRICE))*PipValue*Ord(cnt,VAL_LOTS);				
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit-(OrderOpenPrice()-OrderClosePrice())*OrderLots()/Point; }
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit+(OrderClosePrice()-OrderOpenPrice())*OrderLots()/Point; }
			}
			if (LastType==OP_SELL) 
			{
				//Profit=Profit+(Ord(cnt,VAL_OPENPRICE)-Ord(cnt,VAL_CLOSEPRICE))*PipValue*Ord(cnt,VAL_LOTS);
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit-(OrderClosePrice()-OrderOpenPrice())*OrderLots()/Point; }
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit+(OrderOpenPrice()-OrderClosePrice())*OrderLots()/Point; }
			}
			//Print(Symbol,":",Profit,",",LastLots);
	  }
   }


   if(Money_management) {SecureProfit=(AccountEquity()/LotSizeValue*risk);}
   else
   {SecureProfit=(AccountEquity()/LotSizeValue*lotsi);}

	Profit=Profit*PipValue;
	text2="\nCurrent engine''s profit: $"+DoubleToStr(Profit,2)+" +/-";
   if (OpenOrders>=OrderstoProtect && AccountProtection) 
   {	  
	     //Print(Symbol,":",Profit);
	     if (AccountProfit()>=SecureProfit && GlobalEquityProtect) 
	     {
	        OrderClose(LastTicket,LastLots,LastClosePrice,slippage,Yellow);
	        ContinueOpening=False;
	        return(0);
	     }
	     if (Profit>=SecureProfit && (!GlobalEquityProtect))
	     {
	        OrderClose(LastTicket,LastLots,LastClosePrice,slippage,Yellow);
	        ContinueOpening=False;
	        return(0);
	     }
   }

      if (!IsTesting()) 
      {
	     if (myOrderType==3) { text="\nNo conditions to open trades"; }
	     else { text="                         "; }
	     Comment("\nLastPrice=",LastPrice,"\nPrevious open orders=",PreviousOpenOrders,"\nContinue opening=",
	     ContinueOpening," OrderType=",myOrderType,"\nLot size: ",lotsi,"\nEngine mode=",engine,"\nCurrentGlobalProfit=",AccountProfit(),
	     text2,"\n",text,"\n","\nFreeware available at http://goldenmoneytree.com","\nfor exclusive member",
	     "\nDo not BUY this product!");
      }

      if (myOrderType==1 && ContinueOpening) 
      {	
	     if ((Bid-LastPrice)>=Pips*Point || OpenOrders<1) 
	     {		
		    SellPrice=Bid;				
		    LastPrice=0;
		    if (TakeProfit==0) { tp=0; }
		    else { tp=SellPrice-TakeProfit*Point; }	
		    if (InitialStop==0) { sl=0; }
		    else { sl=NormalizeDouble(SellPrice+InitialStop*Point + (MaxTrades-OpenOrders)*Pips*Point, Digits);  }
		    if (OpenOrders!=0) 
		    {
			      mylotsi=lotsi;			
			      for(cnt=1;cnt<=OpenOrders;cnt++)
			      {
				     if (MaxTrades>12) { mylotsi=NormalizeDouble(mylotsi*1.5,2); }
				     else { mylotsi=NormalizeDouble(mylotsi*Multiplier,2); }
			      }
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    OrderSend(Symbol(),OP_SELL,mylotsi,SellPrice,slippage,sl,tp,"VQ35"+engine,Magic,0,Red);		    		    
		    return(0);
	     }
      }
      
      if (myOrderType==2 && ContinueOpening) 
      {
	     if ((LastPrice-Ask)>=Pips*Point || OpenOrders<1) 
	     {		
		    BuyPrice=Ask;
		    LastPrice=0;
		    if (TakeProfit==0) { tp=0; }
		    else { tp=BuyPrice+TakeProfit*Point; }	
		    if (InitialStop==0)  { sl=0; }
		    else { sl=NormalizeDouble(BuyPrice-InitialStop*Point - (MaxTrades-OpenOrders)*Pips*Point, Digits); }
		    if (OpenOrders!=0) {
			   mylotsi=lotsi;			
			   for(cnt=1;cnt<=OpenOrders;cnt++)
			   {
				  if (MaxTrades>12) { mylotsi=NormalizeDouble(mylotsi*1.5,2); }
				  else { mylotsi=NormalizeDouble(mylotsi*Multiplier,2); }
			   }
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    OrderSend(Symbol(),OP_BUY,mylotsi,BuyPrice,slippage,sl,tp,"VQ35"+engine,Magic,0,Blue);		    
		    return(0);
	     }
      }   

//----
   return(0);
  }
//+------------------------------------------------------------------+
int Conservative()
{
     myOrderType=3;
      double bullhighpre = iBullsPower(NULL,0,Slow_Period,0,Shift+1);
      double bullhighcur = iBullsPower(NULL,0,Slow_Period,0,Shift);
      double bearhighpre = iBearsPower(NULL,0,Slow_Period,0,Shift+1);
      double bearhighcur = iBearsPower(NULL,0,Slow_Period,0,Shift);
      double bulllow = iBullsPower(NULL,0,Fast_Period,0,Shift);
      double bearlow = iBearsPower(NULL,0,Fast_Period,0,Shift);
         if (bearhighcur>bearhighpre && bearhighcur>0 && bearhighpre>0
         && bullhighcur>bullhighpre && bulllow>0 && bearlow>0)
         { myOrderType=2;}
         if (bearhighcur<bearhighpre && bearhighcur<0 && bearhighpre<0
         && bullhighcur<bullhighpre && bulllow<0 && bearlow<0)
         { myOrderType=1;}
	return(myOrderType);
}

int Intermediate()
{
	  int myOrderType=3;
	  if (iMACD(NULL,0,Fast_MA,Slow_MA,MACD_SMA,PRICE_CLOSE,MODE_MAIN,Shift)>0 &&
	  iMACD(NULL,0,Fast_MA,Slow_MA,MACD_SMA,PRICE_CLOSE,MODE_MAIN,Shift+1)<0) { myOrderType=2; }
	  if (iMACD(NULL,0,Fast_MA,Slow_MA,MACD_SMA,PRICE_CLOSE,MODE_MAIN,Shift)<0 &&
	  iMACD(NULL,0,Fast_MA,Slow_MA,MACD_SMA,PRICE_CLOSE,MODE_MAIN,Shift+1)>0) { myOrderType=1; }
	  return(myOrderType);
}

int Agressive()
{
      int myOrderType=3;
      double StochMain = iStochastic(NULL,0,K_Period,D_Period,Slowing,MODE_EMA,1,MODE_MAIN,Shift);
      double StochSignal = iStochastic(NULL,0,K_Period,D_Period,Slowing,MODE_EMA,1,MODE_SIGNAL,Shift);
      double StochShift = iStochastic(NULL,0,K_Period,D_Period,Slowing,MODE_EMA,1,MODE_MAIN,Shift+1);
      double RSI = iRSI(NULL,0,RSI_Period,PRICE_CLOSE,Shift);
      double RSIShift = iRSI(NULL,0,RSI_Period,PRICE_CLOSE,Shift+1);
      double MFI = iMFI(NULL,0,MFI_Period,Shift);
      double MFIShift = iMFI(NULL,0,MFI_Period,Shift+1);
      
      if   (StochMain > StochSignal &&
            StochMain > StochShift &&
            StochMain < Overbought &&
            StochMain > Oversold &&
            RSI > RSIShift &&
            MFI > MFIShift)
            { myOrderType = 2; }

      if   (StochMain < StochSignal &&
            StochMain < StochShift &&
            StochMain < Overbought &&
            StochMain > Oversold &&
            RSI < RSIShift &&
            MFI < MFIShift)
            { myOrderType = 1; }

      return(myOrderType);
}

int Berserk()
{
	  if (iMACD(NULL,0,Fast_MA,Slow_MA,MACD_SMA,PRICE_CLOSE,MODE_MAIN,Shift)>
	  iMACD(NULL,0,Fast_MA,Slow_MA,MACD_SMA,PRICE_CLOSE,MODE_MAIN,Shift+1)) { myOrderType=2; }
	  if (iMACD(NULL,0,Fast_MA,Slow_MA,MACD_SMA,PRICE_CLOSE,MODE_MAIN,Shift)<
	  iMACD(NULL,0,Fast_MA,Slow_MA,MACD_SMA,PRICE_CLOSE,MODE_MAIN,Shift+1)) { myOrderType=1; }
	  return(myOrderType);
}